﻿using C1.Blazor.Grid;
using C1.Blazor.Core;
using Microsoft.JSInterop;
using Microsoft.AspNetCore.Components;
using System.IO;
using Microsoft.AspNetCore.Components.Rendering;
using FlexGridIntro.Client.Shared;
using System;
using System.Drawing;

namespace FlexGridIntro.Client.Models
{
    public class MyGrid : FlexGrid
    {
        public MyGrid() : base()
        {
            Class = "custom";
            DefaultRowHeight = 20;
            Style = "border: 1px solid black; height: 200px; box - sizing:content - box; ";
            ColumnHeaderStyle = "background - colour:#CCCCCC;colour:#fff;font-size:16px;font-weight:bold";
            SelectionAdornerStyle = "border - colour:#3F51B5;colour:#0D47A1";
            AlternatingRowStyle = "background - colour:#F5F5F5";
            AutoGenerateColumns = true;
            AllowFiltering = false;
            AllowResizing = GridAllowResizing.Columns;
            SelectionBackground = "C1.Blazor.Core.C1Colour.LightSkyBlue";
            SelectionMode = GridSelectionMode.Row;
            ColumnOptionsMenuVisibility = GridColumnOptionsMenuVisibility.Collapsed;
            HeadersVisibility = GridHeadersVisibility.Column;
            
        }
    }
    public class MyGridHyperLinkColumn: GridHyperlinkColumn
    {
        [Inject]
        protected NavigationManager nav { get; set; }   
        protected override RenderFragment GetCellContentRenderFragment(GridCellType cellType, GridRow row)
        {
            if(cellType == GridCellType.Cell)
            {   
                var item = row.DataItem;
                var content = item.GetType().GetProperty(this.ContentBinding).GetValue(item);
                var link = item.GetType().GetProperty(this.Binding).GetValue(item);
                RenderFragment anchor = builder =>
                {
                    builder.OpenComponent<Anchor>(1);
                    builder.AddAttribute(2, "Link", link);
                    builder.AddAttribute(3, "Content", content);
                    builder.AddAttribute(4, "onclick",
            Microsoft.AspNetCore.Components.EventCallback.Factory.Create(this,
               () => nav.NavigateTo(link.ToString(), false)));
                    builder.CloseComponent();
                };
                return anchor;
            }
            return base.GetCellContentRenderFragment(cellType, row);
        }

        private RenderFragment AddContent(string content) => builder =>
        {
            builder.AddContent(1, content);
        };
    }
   
}
